/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.contents.text;

import java.io.Serializable;
import kinugasa.contents.resource.Nameable;

/**
 * キーに対して値を保持するための構造体です.
 * <br>
 * このクラスは、INIファイルのデータとして使用されます。<br>
 * キーおよび値はStringとして格納され、それぞれが別のインスタンスの対応するフィールドと等価である
 * 場合（equalsがtrueを返す場合)それらのプロパティは等価とみなされます。<br>
 * <br>
 * Nameableの実装としては、キーを返します。<br>
 *
 * @version 1.0.0<br>
 * @author Dra0211<br>
 */
public class Property implements Serializable, Nameable {

	private static final long serialVersionUID = -5027244314883426876L;
	/** キー. */
	private String key;
	/** 値. */
	private String value;

	/**
	 * 新しいプロパティを構築します.
	 * <br>
	 *
	 * @param key   キー.<br>
	 * @param value 値.<br>
	 */
	public Property(String key, String value) {
		this.key = key;
		this.value = value;
	}

	/**
	 * キーを取得します.
	 * <br>
	 *
	 * @return キーを指定します。<br>
	 */
	public String getKey() {
		return key;
	}

	/**
	 * 値を取得します.
	 * <br>
	 *
	 * @return 値を指定します。<br>
	 */
	public String getValue() {
		return value;
	}

	/**
	 * キーを設定します.
	 *
	 * @param key 新しいキーを指定します。<br>
	 */
	public void setKey(String key) {
		this.key = key;
	}

	/**
	 * 値を設定します.
	 *
	 * @param value 新しい値を指定します。<br>
	 */
	public void setValue(String value) {
		this.value = value;
	}

	/**
	 * キーおよび値を[ley=value]の形式で返します.
	 * <br>
	 *
	 * @return キーと値のペアを返します。<bR>
	 */
	@Override
	public String toString() {
		return key + "=" + value;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final Property other = (Property) obj;
		if ((this.key == null) ? (other.key != null) : !this.key.equals(other.key)) {
			return false;
		}
		if ((this.value == null) ? (other.value != null) : !this.value.equals(other.value)) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 7;
		hash = 29 * hash + (this.key != null ? this.key.hashCode() : 0);
		hash = 29 * hash + (this.value != null ? this.value.hashCode() : 0);
		return hash;
	}

	@Override
	public String getName() {
		return key;
	}
}
